unit Unit1;

//
//v1.0
//(c)2018 Noniewicz.com
//created: 20180901
//updated: 20180902, 03

//todo:
//- bin form for incbin

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls, ExtDlgs, Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    EditPFx: TEdit;
    EditFn: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    OpenPictureDialog1: TOpenPictureDialog;
    RGMode: TRadioGroup;
    SpinEditStart: TSpinEdit;
    SpinEditEnd: TSpinEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    TS: TStringList;
    TS0, TS1, TS2: TStringList;
    TS3, TS4, TS5: TStringList;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

function pix2bit(ca: TCanvas; x, y: integer): byte;
var b, p: integer;
begin
  result := 0;
  if not assigned(ca) then exit;
  p := ca.Pixels[x, y];
  b := ((p and 255) + ((p shr 8) and 255) + ((p shr 16) and 255)) div 3;
  if b > 16 then //min luminosity
    result := 1;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var x, y: integer;
    b0, b1, b2: byte;
    b3, b4, b5: byte;
    ca: TCanvas;
    s: string;
begin
  ca := self.Image1.Picture.Bitmap.Canvas;

  TS0.Clear;
  TS0.Add(EditPFx.Text+'0');
  TS1.Clear;
  TS1.Add(EditPFx.Text+'1');
  TS2.Clear;
  TS2.Add(EditPFx.Text+'2');

  TS3.Clear;
  TS3.Add(EditPFx.Text+'3');
  TS4.Clear;
  TS4.Add(EditPFx.Text+'4');
  TS5.Clear;
  TS5.Add(EditPFx.Text+'5');

  for y := SpinEditEnd.Value downto SpinEditStart.Value do
  begin
    if RGMode.ItemIndex = 2 then
    b0 := pix2bit(ca, 0, y)*128+
          pix2bit(ca, 1, y)*64+
          pix2bit(ca, 2, y)*32+
          pix2bit(ca, 3, y)*16+
          pix2bit(ca, 4, y)*8+
          pix2bit(ca, 5, y)*4+
          pix2bit(ca, 6, y)*2+
          pix2bit(ca, 7, y)*1
    else
    b0 := pix2bit(ca, 0, y)*16+
          pix2bit(ca, 1, y)*32+
          pix2bit(ca, 2, y)*64+
          pix2bit(ca, 3, y)*128;

    b1 := pix2bit(ca, 4, y)*128+   //note reverse!
          pix2bit(ca, 5, y)*64+
          pix2bit(ca, 6, y)*32+
          pix2bit(ca, 7, y)*16+
          pix2bit(ca, 8, y)*8+
          pix2bit(ca, 9, y)*4+
          pix2bit(ca, 10, y)*2+
          pix2bit(ca, 11, y)*1;
    b2 := pix2bit(ca, 12, y)*1+
          pix2bit(ca, 13, y)*2+
          pix2bit(ca, 14, y)*4+
          pix2bit(ca, 15, y)*8+
          pix2bit(ca, 16, y)*16+
          pix2bit(ca, 17, y)*32+
          pix2bit(ca, 18, y)*64+
          pix2bit(ca, 19, y)*128;

    TS0.Add('	.byte '+inttostr(b0)+'	;s '+inttostr(y));
    TS1.Add('	.byte '+inttostr(b1)+'	;s '+inttostr(y));
    TS2.Add('	.byte '+inttostr(b2)+'	;s '+inttostr(y));

    if RGMode.ItemIndex = 1 then
    begin
      b3 := pix2bit(ca, 0, y)*16+
            pix2bit(ca, 1, y)*32+
            pix2bit(ca, 2, y)*64+
            pix2bit(ca, 3, y)*128;
      b4 := pix2bit(ca, 4, y)*128+   //note reverse!
            pix2bit(ca, 5, y)*64+
            pix2bit(ca, 6, y)*32+
            pix2bit(ca, 7, y)*16+
            pix2bit(ca, 8, y)*8+
            pix2bit(ca, 9, y)*4+
            pix2bit(ca, 10, y)*2+
            pix2bit(ca, 11, y)*1;
      b5 := pix2bit(ca, 12, y)*1+
            pix2bit(ca, 13, y)*2+
            pix2bit(ca, 14, y)*4+
            pix2bit(ca, 15, y)*8+
            pix2bit(ca, 16, y)*16+
            pix2bit(ca, 17, y)*32+
            pix2bit(ca, 18, y)*64+
            pix2bit(ca, 19, y)*128;

      TS3.Add('	.byte '+inttostr(b3)+'	;s '+inttostr(y));
      TS4.Add('	.byte '+inttostr(b4)+'	;s '+inttostr(y));
      TS5.Add('	.byte '+inttostr(b5)+'	;s '+inttostr(y));
    end;

  end;

  s := '; Atari 2600 TIA playfield generator v1.0'#13#10;
  s := s + '; lines: ' + inttostr(SpinEditEnd.Value) + ' - ' + inttostr(SpinEditStart.Value) + #13#10#13#10;

  try
    TS.Clear;
    case RGMode.ItemIndex of
      0: TS.Text := s + TS0.Text + #13#10 + TS1.Text + #13#10 + TS2.Text;
      1: TS.Text := s + TS0.Text + #13#10 + TS1.Text + #13#10 + TS2.Text + #13#10+
                        TS3.Text + #13#10 + TS4.Text + #13#10 + TS5.Text;
      2: TS.Text := s + TS0.Text;
    end;
    TS.SaveToFile(EditFn.Text);
  except
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
  try
    self.Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
  except
  end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var bmp: TBitmap;
    x, y: integer;
begin
  bmp := TBitmap.Create;
  bmp.Width := image1.Picture.Bitmap.Width;
  bmp.Height := image1.Picture.Bitmap.Height;
  for y := 0 to (bmp.Height-1) div 2 do
    for x := 0 to bmp.Width-1 do
    begin
      bmp.Canvas.Pixels[x, y*2+0] := image1.Picture.Bitmap.Canvas.Pixels[x, y];
      bmp.Canvas.Pixels[x, y*2+1] := image1.Picture.Bitmap.Canvas.Pixels[x, y];
    end;
  image1.Picture.Bitmap.Assign(bmp);
  bmp.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TS := TStringList.Create;
  TS0 := TStringList.Create;
  TS1 := TStringList.Create;
  TS2 := TStringList.Create;
  TS3 := TStringList.Create;
  TS4 := TStringList.Create;
  TS5 := TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  TS.Free;
  TS0.Free;
  TS1.Free;
  TS2.Free;
  TS3.Free;
  TS4.Free;
  TS5.Free;
end;

end.

